/**
 * Give developer ability to add extra params to permanent link.
 * Can be used for tracking parameters for example
 * @param {string} paramsToAdd - Extra params to add to permanent link
 */
declare const setExtraQueryParam: (paramsToAdd: string) => void;
/**
 * Create Permanent Link function.
 * @returns {string} - Generated permanent link
 */
declare const createUrl: () => string;
/**
 * Decode liff.state
 * If valid, return decoded state (with any double slashes removed)
 * Else LiffError is thrown
 * @param {string} state - liff.state's value
 * @throws {LiffError}
 * @returns {string} - Decoded liff.state with any double slashes removed
 */
declare const decodeState: (state: string) => string;
export { decodeState, createUrl, setExtraQueryParam };
