import init from './init';
import getOS from './common/getOS';
import getVersion from './common/getVersion';
import getLanguage from './common/getLanguage';
import isInClient from './common/isInClient';
import isLoggedIn from './auth/isLoggedIn';
import login from './auth/login';
import logout from './auth/logout';
import { getAccessToken, getFeatures, getContext, getIDToken, getDecodedIDToken } from './store';
import { dispatch, call, postMessage, addListener, removeListener } from './client/bridge';
import checkFeature from './client/checkFeature';
import openWindow from './client/openWindow';
import closeWindow from './client/closeWindow';
import getAId from './client/getAId';
import getProfilePlus from './client/getProfilePlus';
import getIsVideoAutoPlay from './client/getIsVideoAutoPlay';
import getLineVersion from './client/getLineVersion';
import getProfile from './api/getProfile';
import sendMessages from './api/sendMessages';
import userPicker from './api/userPicker';
import shareTargetPicker from './api/shareTargetPicker';
import getFriendship from './api/getFriendship';
import { LiffExtendableFunctions } from './init/definition/LiffExtension';
declare const liffCore: {
    init: typeof init;
    getOS: typeof getOS;
    getVersion: typeof getVersion;
    getLanguage: typeof getLanguage;
    isInClient: typeof isInClient;
    isLoggedIn: typeof isLoggedIn;
    login: typeof login;
    logout: typeof logout;
    getAccessToken: typeof getAccessToken;
    getIDToken: typeof getIDToken;
    getDecodedIDToken: typeof getDecodedIDToken;
    getContext: typeof getContext;
    openWindow: typeof openWindow;
    closeWindow: typeof closeWindow;
    getFeatures: typeof getFeatures;
    getFriendship: typeof getFriendship;
    checkFeature: typeof checkFeature;
    getAId: typeof getAId;
    getProfilePlus: typeof getProfilePlus;
    getIsVideoAutoPlay: typeof getIsVideoAutoPlay;
    getLineVersion: typeof getLineVersion;
    isApiAvailable: (apiName: "shareTargetPicker") => boolean;
    getProfile: typeof getProfile;
    sendMessages: typeof sendMessages;
    userPicker: typeof userPicker;
    shareTargetPicker: typeof shareTargetPicker;
    permanentLink: {
        createUrl: () => string;
        setExtraQueryParam: (paramsToAdd: string) => void;
    };
    ready: Promise<void>;
    /**
     * The property that holds the LIFF app ID (String type) passed to liff.init().
     * The value of liff.id is null until you run liff.init().
     */
    readonly id: string | null;
    _dispatchEvent: typeof dispatch;
    _call: typeof call;
    _addListener: typeof addListener;
    _removeListener: typeof removeListener;
    _postMessage: typeof postMessage;
};
export declare type LiffCore = typeof liffCore;
declare type Liff = LiffCore & LiffExtendableFunctions;
declare const liff: Liff;
export default liff;
