export interface ReceiveEvent extends MessageEvent {
    data: {
        name: string;
        body: {} | {}[];
    };
}
/**
 * callback function called at first when receive a message event. (strictly speaking, listen.ts is called at very first)
 * before calling callback you designated, this verifies if the name and origin are same as you expected
 * @param name
 * @param callback
 * @param targetOrigin
 */
export declare function verifyCallback(name: string, callback: Function, targetOrigin: string): (event: ReceiveEvent) => void;
/**
 * receive Event from another window calling postMessage.
 * This is used for receiving data from another window like iframe, popup window, etc.
 * @param target
 * @param name
 * @param callback
 * @param targetOrigin
 */
export default function receive(target: Window, name: string, callback: Function, targetOrigin: string): void;
